﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace userC
{
    /// <summary>
    /// Interaction logic for UserControl1.xaml
    /// </summary>
    public partial class UserControl1 : UserControl
    {

        #region DP
        public string City
        {
            get
            {
                return (string)this.GetValue(CityProperty);
            }
            set
            {
                SetValue(CityProperty, value);
            }
        }



        public static DependencyProperty CityProperty = DependencyProperty.Register("City", typeof(string), typeof(UserControl1), new PropertyMetadata("长春"));

        public string Temperature
        {
            get
            {
                return (string)this.GetValue(TemperatureProperty);
            }
            set
            {
                SetValue(TemperatureProperty, value);
            }
        }

        public static DependencyProperty TemperatureProperty = DependencyProperty.Register("Temperature", typeof(string), typeof(UserControl1), new PropertyMetadata("20"));

        public string ImagePath
        {
            get
            {
                return (string)this.GetValue(ImagePathProperty);
            }
            set
            {
                SetValue(ImagePathProperty, value);
            }
        }

        public static DependencyProperty ImagePathProperty = DependencyProperty.Register("ImagePath", typeof(string), typeof(UserControl1), new PropertyMetadata("null"));

        public Brush Background
        {
            get
            {
                return (Brush)this.GetValue(BackgroundProperty);
            }
            set
            {
                SetValue(BackgroundProperty, value);
            }
        }

        public static DependencyProperty BackgroundProperty = DependencyProperty.Register("Background", typeof(Brush), typeof(UserControl1), new PropertyMetadata(Brushes.Cyan));

        #endregion


        public UserControl1()
        {
            InitializeComponent();
        }

        protected override void OnInitialized(EventArgs e)
        {
            base.OnInitialized(e);

            Binding cityBinding = new Binding();
            cityBinding.Source = this;
            cityBinding.Path = new PropertyPath(UserControl1.CityProperty);
            this.txtCity.SetBinding(TextBlock.TextProperty, cityBinding);

            Binding temBinding = new Binding();
            temBinding.Source = this;
            temBinding.Path = new PropertyPath(UserControl1.TemperatureProperty);
            this.txtTemp.SetBinding(TextBlock.TextProperty, temBinding);

            Binding imgBinding = new Binding();
            imgBinding.Source = this;
            imgBinding.Path = new PropertyPath(UserControl1.ImagePathProperty);
            this.img.SetBinding(Image.SourceProperty, imgBinding);

            Binding bgBinding = new Binding();
            bgBinding.Source = this;
            bgBinding.Path = new PropertyPath(UserControl1.BackgroundProperty);
            this.gd.SetBinding(Grid.BackgroundProperty, bgBinding);
        }
    }
}
